<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/email.asp" -->
<!-- #include file="includes/encryption.asp" -->
<!-- #include file="includes/form.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If server-side email is enabled, redirect to the home page.
	if not SERVER_EMAIL_ENABLED then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Contact"
	call BuildPageHeader("", "")

 	if IsAdmin() then %>
	<style type="text/css">
	.listPanel {
		border: 1px solid #809cb8;
		max-height: 108px;
		overflow: auto;
		padding: .5em;
		border-radius: .25em;
		-moz-border-radius: .25em;
		-webkit-border-radius: .25em;
	}
	</style>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Module: contactFields
	//
	// Used to maintain the contact fields.
	//=========================================================================
	var contactFields = function (){

		//=====================================================================
		// Public properties and methods.
		//=====================================================================
		return {

			//-----------------------------------------------------------------
			// Should be called prior to form submittal to copy the email
			// addresses of all checked contact fields to the hidden recipients
			// field.
			//-----------------------------------------------------------------
			buildRecipients : function (formEl) {

				// Find all selected recipients.
				var list = [];
				var i = 1;
				do {
					var contactEl = formEl.elements["contact-" + i];
					if (contactEl != null && !contactEl.disabled && contactEl.checked)
					{
						// Add the email to the recipients array.
						list.push(contactEl.value)
					}
					i++;
				} while(contactEl != null);

				// For the recipients field, make a comma-separated string out
				// of the array.
				formEl.elements["recipients"].value = list.join(",");

				return true;
			},

			//-----------------------------------------------------------------
			// Should be called whenever a contact field is checked or
			// unchecked to update the status of the 'all' checkbox field.
			//-----------------------------------------------------------------
			setAll : function (checkboxEl) {

				var allEl = checkboxEl.form.elements["allContacts"];
				var i = 1;
				do {
					var contactEl = checkboxEl.form.elements["contact-" + i];
					if (contactEl != null && !contactEl.disabled && !contactEl.checked) {

						// At least one recipient is not checked so uncheck the
						// 'all' checkbox and exit.
						allEl.checked = false;

						return true;
					}
					i++;
				} while(contactEl != null);

				// All contacts are checked so check the 'All' checkbox as
				// well.
				allEl.checked = true;

				return true;
			},

			//-----------------------------------------------------------------
			// Should be called whenever the 'all' field is checked or
			// unchecked to check/uncheck all the contact fields accordingly.
			//-----------------------------------------------------------------
			setContacts : function (checkboxEl) {

				var i = 1;
				do {
					var contactEl = checkboxEl.form.elements["contact-" + i];
					if (contactEl != null && !contactEl.disabled)
						contactEl.checked = checkboxEl.checked;
					i++;
				} while(contactEl != null);

				return true;
			}
		}
	}();
	//]]></script>
<%	end if %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Build the list of contacts.
	dim sql, rs, curWeek
	dim list, n, t1, t2
    curWeek = GetCurrentWeek()

       SQL = "SELECT Username, EmailAddress FROM Users" _
       & " WHERE Username IN (SELECT Username FROM SurvivorStatus WHERE Week =  " & curWeek _
       & " AND Missed <> 1 AND IsAlive = True AND NOT EXISTS (SELECT Username FROM SidePicks WHERE week =  " & curWeek _
       & " AND SurvivorStatus.Username = SidePicks.Username))" _
       & " ORDER BY Username"
    
	set rs = DbConn.Execute(sql)
	do while not rs.EOF
		if not IsArray(list) then
			redim list(0)
		else
			redim preserve list(UBound(list) + 1)
		end if
		n = UBound(list)
		set list(n) = new ContactObj
		list(n).name  = rs.Fields("Username").Value
		list(n).email = Decrypt(rs.Fields("EmailAddress").Value)
		rs.MoveNext
	loop

	'Create a contact for the admin.
	dim adminContact
	set adminContact = new ContactObj
	adminContact.name  = ADMIN_USERNAME
	adminContact.email = ADMIN_EMAIL

	'If there is form data, process it.
	dim recipients, subject, message
	dim fromContact
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest() then
		recipients = Trim(Request.Form("recipients"))
		subject    = Trim(Request.Form("subject"))
		message    = Trim(Request.Form("message"))

		'If the user is the Administrator, ensure at least one recipient was
		'selected. Otherwise, make the Administrator the recipient.
		if IsAdmin() then
			if recipients = "" then
				FormFieldErrors.Add "recipients", "At least one recipient must be selected."
			end if
		else
			recipients = ADMIN_USERNAME
		end if

		'Validate the subject and message fields.
		if subject = "" then
			FormFieldErrors.Add "subject", "A subject is required."
		end if
		if message = "" then
			FormFieldErrors.Add "message", "The message may not be empty."
		end if

		'Set the contact for the sender.
		if IsAdmin() then
			set fromContact = adminContact
		else
			set	fromContact = new ContactObj
			fromContact.name  = Session(SESSION_USERNAME_KEY)
			fromContact.email = GetUserEmailAddress(fromContact.name)
		end if

		'If there were any errors, display the error messages. Otherwise, send
		'the email.
		if FormFieldErrors.Count > 0 then
			call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
		else
			call SendMessages()
			call DisplaySuccessMessage("Message sent.")
		end if
	end if

	'Display the form. %>
	<form id="contactForm" action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post"<% if IsAdmin then Response.Write("onsubmit=""return contactFields.buildRecipients(this);""") end if %>>
		<input type="hidden" name="recipients" value="" />
		<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
<%	if IsAdmin() then %>
				<th align="left">Contact Users</th>
<%	else %>
				<th align="left">Contact the Administrator</th>
<%	end if %>
			</tr>
			<tr>
				<td class="freeForm">
<%	if IsAdmin() then

		'Define layout for contacts.
		dim numCols, numRows
		dim lastMaxCol
		dim i, j, k
		numCols = 3

		'Display the contacts.
		if IsArray(list) then
			n = UBound(list) + 1
			lastMaxCol = n mod numCols
			if n <= numCols then
				numRows = 1
			else
				numRows = Fix(n / numCols)
				if lastMaxCol > 0 then
					numRows = numRows + 1
				end if
			end if %>
					<strong>Recipients:</strong><br />
					<div class="<% = StyleFormField("listPanel", "recipients") %>">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr class="singleLine" valign="top">
<%			i = 0
			for j = 1 to numCols %>
								<td style="width: 12em;">
<%				if lastMaxCol > 0 and j = lastMaxCol + 1 then
					numRows = numRows - 1
				end if
				for k = 1 to numRows
					if i < n then
						call DisplayContactField(list(i))
						i = i + 1
					end if
				next %>
								</td>
<%			next %>
							</tr>
						</table>
					</div>
					<p><input type="checkbox" id="allContacts" name="allContacts" value="true"<% if not IsCancelRequest() and FormFieldExists("allContacts") then Response.Write(" checked=""checked""") end if %> onclick="return contactFields.setContacts(this)" /><label for="allContacts">All</label></p>
<%		else %>
					<em>No users found.</em>
<%		end if %>
<%	end if %>
					<!--[if lt IE 8]><div class="adjustWidth"><![endif]-->
					<p><strong>Subject:</strong><br />
					<input type="text" name="subject" value="<% = subject %>" style="width: 100%;" class="<% = StyleFormField("", "subject") %>" /></p>
					<p><strong>Message:</strong><br />
					<textarea name="message" rows="20" style="width: 100%;" class="<% = StyleFormField("", "message") %>"><% = message %></textarea></p>
					<!--[if lt IE 8]></div><![endif]-->
				</td>
			</tr>
		</table>
		<p><input type="submit" name="submit" value="Send" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Searches the contacts list for the specified username and returns the
	' email address associated with it. If no email address is found, an empty
	' string is returned.
	'--------------------------------------------------------------------------
	function GetUserEmailAddress(name)

		dim i

		GetUserEmailAddress = ""
		if IsArray(list) then
			for i = 0 to UBound(list)
				if list(i).name = name then
					GetUserEmailAddress = list(i).email
					exit function
				end if
			next
		end if

	end function

	'--------------------------------------------------------------------------
	' Builds a checkbox field for the given contact.
	'--------------------------------------------------------------------------
	sub DisplayContactField(contact)

		dim str

		str = "<span title=""" & contact.email & """>"
		str = str & "<input type=""checkbox"" id=""contact-" & (i + 1) & """ name=""contact-" & (i + 1) & """"
		str = str & " value=""" & contact.name & """"
		if not IsCancelRequest() and FormFieldExists("contact-" & (i + 1)) then
			str = str & " checked=""checked"""
		end if
		if contact.email <> "" then
			str = str & " onclick=""return contactFields.setAll(this);"" />"
		else
			str = str & " disabled=""disabled"" />"
		end if
		str = str & "<label for=""contact-" & (i + 1) & """>" & contact.name & "</label>"
		str = str & "</span><br />"

		Response.Write(String(12, vbTab) & str)

	end sub

	'--------------------------------------------------------------------------
	' Sends the email to each recipient.
	'--------------------------------------------------------------------------
	sub SendMessages()

		dim names, name, email

		'If this is the Admin, send the email to each recipient selected.
		'Otherwise, send the email to the Admin.
		if IsAdmin() then
			names = Split(recipients, ",")
			for each name in names
				email = GetUserEmailAddress(name)
				call SendMail(email, subject, message)
			next
		else
			name  = Session(SESSION_USERNAME_KEY)
			email = GetUserEmailAddress(name)
			call SendMail(adminContact.email, subject, "FROM: " & name & "(" & email & ")" & vbCrLf & vbCrLf & message)
		end if

	end sub

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' ContactObj: Holds information for a single contact.
	'--------------------------------------------------------------------------
	class ContactObj

		public name
		public email

	end class %>
